Index: vl.c
===================================================================
--- vl.c	(revision 4734)
+++ vl.c	(working copy)
@@ -7665,8 +7780,951 @@
 }
 #endif
 
-#define MAX_NET_CLIENTS 32
+/***************************************************/
 
+typedef struct QEMUIRQVector {
+    const char *name;
+    qemu_irq *irqs;
+    int nb_irqs;
+    struct QEMUIRQVector *next;
+} QEMUIRQVector;
+
+static QEMUIRQVector *first_irq_vec;
+QEMUDeviceClass *qemu_eth_class;
+QEMUDeviceClass *qemu_isa_class;
+QEMUDeviceClass *qemu_default_pic_class;
+
+/* primitive IRQ naming, waiting until PICs are registered as
+   objects. */
+void qemu_register_irqs(const char *name, qemu_irq *irqs, int nb_irqs)
+{
+    QEMUIRQVector *irq_vec;
+    QEMUDevice *dev;
+
+    dev = qemu_device_new_after(qemu_default_pic_class, name, machine_dev);
+    if (!dev)
+        return;
+    dev->instantiated = 1;
+    irq_vec = qemu_mallocz(sizeof(QEMUIRQVector));
+    irq_vec->name = qemu_strdup(name);
+    irq_vec->irqs = irqs;
+    irq_vec->nb_irqs = nb_irqs;
+    irq_vec->next = first_irq_vec;
+    first_irq_vec = irq_vec;
+}
+
+/* XXX: must be suppressed asap */
+qemu_irq *qemu_get_default_pic(void)
+{
+    if (!first_irq_vec)
+        return NULL;
+    return first_irq_vec->irqs;
+}
+
+/* return NULL if not found */
+qemu_irq *qemu_irq_vec_from_name(const char *name, int nb_irqs)
+{
+    const char *p;
+    char dev_name[256], *q;
+    int irq_index;
+    QEMUIRQVector *irq_vec;
+
+    p = name;
+    q = dev_name;
+    while (*p != '.' && *p != '\0') {
+        if ((q - dev_name) >= sizeof(dev_name) - 1)
+            return NULL;
+        *q++ = *p++;
+    }
+    *q = '\0';
+    if (!strstart(p, ".irq", &p))
+        return NULL;
+    irq_index = strtoul(p, (char **)&p, 10);
+    if (*p != '\0')
+        return NULL;
+    for(irq_vec = first_irq_vec; irq_vec != NULL; irq_vec = irq_vec->next) {
+        if (!strcmp(irq_vec->name, dev_name))
+            break;
+    }
+    if (!irq_vec)
+        return NULL;
+    if (irq_index < 0 || (irq_index + nb_irqs - 1) >= irq_vec->nb_irqs)
+        return NULL;
+    return irq_vec->irqs + irq_index;
+}
+
+/* return NULL if not found */
+qemu_irq qemu_irq_from_name(const char *name)
+{
+    qemu_irq *irq_vec;
+    irq_vec = qemu_irq_vec_from_name(name, 1);
+    if (!irq_vec)
+        return NULL;
+    return irq_vec[0];
+}
+
+char *qemu_irq_name(char *buf, int buf_size, qemu_irq *pic, int irq_num)
+{
+    QEMUIRQVector *irq_vec;
+    for(irq_vec = first_irq_vec; irq_vec != NULL; irq_vec = irq_vec->next) {
+        if (irq_vec->irqs == pic)
+            break;
+    }
+    if (!irq_vec)
+        goto fail;
+    if (irq_num < 0 || irq_num >= irq_vec->nb_irqs)
+        goto fail;
+    snprintf(buf, buf_size, "%s.irq%d", irq_vec->name, irq_num);
+    return buf;
+ fail:
+    buf[0] = '\0';
+    return buf;
+}
+
+/* return NULL if error */
+PCIBus *pci_get_bus_devfn(QEMUDevice *dev, int *pdevfn)
+{
+    PCIBus *pci_bus;
+    const char *str;
+    str = qemu_device_get_str(dev, "pci_bus");
+    pci_bus = pci_bus_from_name(str);
+    if (!pci_bus) {
+        fprintf(stderr, "%s: unknown PCI bus: '%s'\n", dev->name, str);
+        return NULL;
+    }
+    *pdevfn = qemu_device_get_int(dev, "devfn");
+    return pci_bus;
+}
+                                 
+
+#ifdef HAS_AUDIO
+static AudioState *audio_state;
+
+/* XXX: all the following will be moved to device or machine C definitions */
+static int pci_audio_init(QEMUDevice *dev)
+{
+    int (*init_pci) (PCIBus *bus, AudioState *s);
+    PCIBus *pci_bus;
+    int devfn;
+
+    pci_bus = pci_get_bus_devfn(dev, &devfn);
+    if (!pci_bus)
+        return -1;
+    if (!audio_state) {
+        audio_state = AUD_init();
+    }
+    init_pci = dev->dev_class->opaque;
+    init_pci(pci_bus, audio_state);
+    return 0;
+}
+
+static int isa_audio_init(QEMUDevice *dev)
+{
+    int (*init_isa) (AudioState *s, qemu_irq *pic);
+    qemu_irq *pic;
+    pic = qemu_get_default_pic();
+    if (!pic)
+        return -1;
+    if (!audio_state) {
+        audio_state = AUD_init();
+    }
+    init_isa = dev->dev_class->opaque;
+    init_isa(audio_state, pic);
+    return 0;
+}
+#endif
+
+static const uint8_t default_macaddr[6] = {
+    0x52, 0x54, 0x00, 0x12, 0x34, 0x56,
+};
+    
+int nd_init(QEMUDevice *dev, NICInfo *nd)
+{
+    static int nic_count = 0;
+    int vlan_id;
+    const char *str;
+    uint8_t *macaddr;
+
+    vlan_id = qemu_device_get_int(dev, "vlan");
+    nd->vlan = qemu_find_vlan(vlan_id);
+    if (!nd->vlan) {
+        fprintf(stderr, "%s: could not create vlan %d\n", dev->name, vlan_id);
+        return -1;
+    }
+    nd->vlan->nb_guest_devs++;
+
+    str = qemu_device_get_str(dev, "macaddr");
+    if (str[0] == '\0') {
+        macaddr = nd->macaddr;
+        memcpy(macaddr, default_macaddr, 6);
+        macaddr[5] = 0x56 + nic_count;
+    } else {
+        if (parse_macaddr(nd->macaddr, str) < 0) {
+            fprintf(stderr, "%s: invalid syntax for ethernet address\n",
+                    dev->name);
+            return -1;
+        }
+    }
+    nic_count++;
+    return 0;
+}
+
+/* return a "global" macaddr by taking the one of the first defined
+   ethernet device */
+void qemu_get_machine_macaddr(uint8_t *macaddr)
+{
+    QEMUDevice *dev;
+    const char *str;
+
+    for(dev = qemu_first_device; dev != NULL; dev = dev->dev_next) {
+        if (qemu_class_instanceof(dev->dev_class, qemu_eth_class)) {
+            str = qemu_device_get_str(dev, "macaddr");
+            if (str[0] == '\0' ||
+                parse_macaddr(macaddr, str) < 0)
+                goto default_mac;
+            return;
+        }
+    }
+ default_mac:
+    macaddr[0] = 0x52;
+    macaddr[1] = 0x54;
+    macaddr[2] = 0x00;
+    macaddr[3] = 0x12;
+    macaddr[4] = 0x34;
+    macaddr[5] = 0x56;
+}
+
+static int pci_eth_init(QEMUDevice *dev)
+{
+    void (*init_pci)(PCIBus *bus, NICInfo *nd, int devfn);
+    NICInfo nd;
+    PCIBus *pci_bus;
+    int devfn;
+    
+    pci_bus = pci_get_bus_devfn(dev, &devfn);
+    if (!pci_bus)
+        return -1;
+    if (nd_init(dev, &nd) < 0)
+        return -1;
+    init_pci = dev->dev_class->opaque;
+    init_pci(pci_bus, &nd, devfn);
+    return 0;
+}
+
+#define NE2000_NB_MAX 6
+
+static const int ne2000_io[NE2000_NB_MAX] = { 0x300, 0x320, 0x340, 0x360, 0x280, 0x380 };
+static const int ne2000_irq[NE2000_NB_MAX] = { 9, 10, 11, 3, 4, 5 };
+
+static int isa_ne2000_dev_init(QEMUDevice *dev)
+{
+    static int ne2000_count = 0;
+    uint32_t iobase;
+    NICInfo nd;
+    qemu_irq irq;
+    const char *irq_str;
+    char buf[128];
+
+    iobase = qemu_device_get_int(dev, "iobase");
+    irq_str = qemu_device_get_str(dev, "irq");
+    if (iobase == -1 && irq_str[0] == '\0') {
+        if (ne2000_count >= NE2000_NB_MAX)
+            return -1;
+        iobase = ne2000_io[ne2000_count];
+        snprintf(buf, sizeof(buf), "isapic0.irq%d", 
+                 ne2000_irq[ne2000_count]);
+        irq_str = buf;
+        ne2000_count++;
+    }
+    irq = qemu_irq_from_name(irq_str);
+    if (!irq)
+        return -1;
+    if (nd_init(dev, &nd) < 0)
+        return -1;
+    isa_ne2000_init(iobase, irq, &nd);
+    return 0;
+}
+
+void isa_ne2000_class_init(void)
+{
+    QEMUDeviceClass *dc;
+
+    dc = qemu_class_new("ne2k_isa", 0, "NE2000 ISA");
+    qemu_class_add_parent(dc, qemu_eth_class);
+    qemu_class_add_parent(dc, qemu_isa_class);
+    qemu_class_field_new(dc, "iobase", QEMU_CTYPE_INT);
+    qemu_class_set_int(dc, "iobase", -1);
+    qemu_class_field_new(dc, "irq", QEMU_CTYPE_STR);
+    dc->dev_init = isa_ne2000_dev_init;
+}
+
+#ifdef TARGET_ARM
+static int smc91c111_dev_init(QEMUDevice *dev)
+{
+    int64_t membase;
+    qemu_irq irq;
+    NICInfo nd;
+
+    membase = qemu_device_get_int(dev, "membase");
+    irq = qemu_irq_from_name(qemu_device_get_str(dev, "irq"));
+    if (!irq)
+        return -1;
+    if (nd_init(dev, &nd) < 0)
+        return -1;
+    smc91c111_init(&nd, membase, irq);
+    return 0;
+}
+
+void smc91c111_set_defaults(uint32_t membase, qemu_irq *pic, int irq_num)
+{
+    QEMUDevice *dev;
+    QEMUDeviceClass *dc;
+    char buf[128];
+
+    dc = qemu_class_find("smc91c111");
+    if (!dc)
+        return;
+    for(dev = qemu_first_device; dev != NULL; dev = dev->dev_next) {
+        if (dev->dev_class == dc) {
+            if (qemu_device_get_int(dev, "membase") == -1) {
+                qemu_device_set_int(dev, "membase", membase);
+            }
+            if (qemu_device_get_str(dev, "irq")[0] == '\0') {
+                qemu_device_set_str(dev, "irq", 
+                                    qemu_irq_name(buf, sizeof(buf), pic, irq_num));
+            }
+            break;
+        }
+    }
+}
+
+void smc91c111_class_init(void)
+{
+    QEMUDeviceClass *dc;
+
+    dc = qemu_class_new("smc91c111", 0, "smc91c111");
+    qemu_class_add_parent(dc, qemu_eth_class);
+    qemu_class_field_new(dc, "membase", QEMU_CTYPE_INT);
+    qemu_class_set_int(dc, "membase", -1);
+    qemu_class_field_new(dc, "irq", QEMU_CTYPE_INT);
+    qemu_class_set_int(dc, "irq", -1);
+    dc->dev_init = smc91c111_dev_init;
+}
+
+static int mv88w8618_eth_dev_init(QEMUDevice *dev)
+{
+    int64_t membase;
+    NICInfo nd;
+    qemu_irq irq;
+
+    membase = qemu_device_get_int(dev, "membase");
+    irq = qemu_irq_from_name(qemu_device_get_str(dev, "irq"));
+    if (!irq)
+        return -1;
+    if (nd_init(dev, &nd) < 0)
+        return -1;
+    mv88w8618_eth_init(&nd, membase, irq);
+    return 0;
+}
+
+void mv88w8618_eth_set_defaults(uint32_t membase, qemu_irq *pic, int irq_num)
+{
+    QEMUDevice *dev;
+    QEMUDeviceClass *dc;
+    char buf[128];
+
+    dc = qemu_class_find("mv88w8618_eth");
+    if (!dc)
+        return;
+    for(dev = qemu_first_device; dev != NULL; dev = dev->dev_next) {
+        if (dev->dev_class == dc) {
+            if (qemu_device_get_int(dev, "membase") == -1) {
+                qemu_device_set_int(dev, "membase", membase);
+            }
+            if (qemu_device_get_str(dev, "irq")[0] == '\0') {
+                qemu_device_set_str(dev, "irq", 
+                                    qemu_irq_name(buf, sizeof(buf), pic, irq_num));
+            }
+            break;
+        }
+    }
+}
+
+void mv88w8618_eth_class_init(void)
+{
+    QEMUDeviceClass *dc;
+
+    dc = qemu_class_new("mv88w8618_eth", 0, "mv88w8618_eth");
+    qemu_class_add_parent(dc, qemu_eth_class);
+    qemu_class_field_new(dc, "membase", QEMU_CTYPE_INT);
+    qemu_class_set_int(dc, "membase", -1);
+    qemu_class_field_new(dc, "irq", QEMU_CTYPE_STR);
+    dc->dev_init = mv88w8618_eth_dev_init;
+}
+
+static int stellaris_enet_dev_init(QEMUDevice *dev)
+{
+    int64_t membase;
+    qemu_irq irq;
+    NICInfo nd;
+
+    membase = qemu_device_get_int(dev, "membase");
+    irq = qemu_irq_from_name(qemu_device_get_str(dev, "irq"));
+    if (!irq)
+        return -1;
+    if (nd_init(dev, &nd) < 0)
+        return -1;
+    stellaris_enet_init(&nd, membase, irq);
+    return 0;
+}
+
+void stellaris_enet_set_defaults(uint32_t membase, qemu_irq *pic, int irq_num)
+{
+    QEMUDevice *dev;
+    QEMUDeviceClass *dc;
+    char buf[128];
+
+    dc = qemu_class_find("stellaris_enet");
+    if (!dc)
+        return;
+    for(dev = qemu_first_device; dev != NULL; dev = dev->dev_next) {
+        if (dev->dev_class == dc) {
+            if (qemu_device_get_int(dev, "membase") == -1) {
+                qemu_device_set_int(dev, "membase", membase);
+            }
+            if (qemu_device_get_str(dev, "irq")[0] == '\0') {
+                qemu_device_set_str(dev, "irq", 
+                                    qemu_irq_name(buf, sizeof(buf), pic, irq_num));
+            }
+            break;
+        }
+    }
+}
+
+void stellaris_enet_class_init(void)
+{
+    QEMUDeviceClass *dc;
+
+    dc = qemu_class_new("stellaris_enet", 0, "stellaris_enet");
+    qemu_class_add_parent(dc, qemu_eth_class);
+    qemu_class_field_new(dc, "membase", QEMU_CTYPE_INT);
+    qemu_class_set_int(dc, "membase", -1);
+    qemu_class_field_new(dc, "irq", QEMU_CTYPE_STR);
+    dc->dev_init = stellaris_enet_dev_init;
+}
+#endif
+
+#ifdef TARGET_MIPS
+static int mipsnet_dev_init(QEMUDevice *dev)
+{
+    int iobase;
+    NICInfo nd;
+    qemu_irq irq;
+
+    iobase = qemu_device_get_int(dev, "iobase");
+    irq = qemu_irq_from_name(qemu_device_get_str(dev, "irq"));
+    if (!irq)
+        return -1;
+    if (nd_init(dev, &nd) < 0)
+        return -1;
+    mipsnet_init(iobase, irq, &nd);
+    return 0;
+}
+
+void mipsnet_set_defaults(uint32_t iobase, qemu_irq *pic, int irq_num)
+{
+    QEMUDevice *dev;
+    QEMUDeviceClass *dc;
+    char buf[128];
+
+    dc = qemu_class_find("mipsnet");
+    if (!dc)
+        return;
+    for(dev = qemu_first_device; dev != NULL; dev = dev->dev_next) {
+        if (dev->dev_class == dc) {
+            if (qemu_device_get_int(dev, "iobase") == -1) {
+                qemu_device_set_int(dev, "iobase", iobase);
+            }
+            if (qemu_device_get_str(dev, "irq")[0] == '\0') {
+                qemu_device_set_str(dev, "irq", 
+                                    qemu_irq_name(buf, sizeof(buf), pic, irq_num));
+            }
+            break;
+        }
+    }
+}
+
+void mipsnet_class_init(void)
+{
+    QEMUDeviceClass *dc;
+
+    dc = qemu_class_new("mipsnet", 0, "mipsnet");
+    qemu_class_add_parent(dc, qemu_eth_class);
+    qemu_class_field_new(dc, "iobase", QEMU_CTYPE_INT);
+    qemu_class_set_int(dc, "iobase", -1);
+    qemu_class_field_new(dc, "irq", QEMU_CTYPE_STR);
+    dc->dev_init = mipsnet_dev_init;
+}
+#endif
+
+#ifdef TARGET_M68K
+static int mcf_fec_dev_init(QEMUDevice *dev)
+{
+    int64_t membase;
+    NICInfo nd;
+    qemu_irq *irq;
+
+    membase = qemu_device_get_int(dev, "membase");
+    irq = qemu_irq_vec_from_name(qemu_device_get_str(dev, "irq"), 12);
+    if (!irq)
+        return -1;
+    if (nd_init(dev, &nd) < 0)
+        return -1;
+    mcf_fec_init(&nd, membase, irq);
+    return 0;
+}
+
+void mcf_fec_set_defaults(uint32_t membase, qemu_irq *pic, int irq_num)
+{
+    QEMUDevice *dev;
+    QEMUDeviceClass *dc;
+    char buf[128];
+
+    dc = qemu_class_find("mcf_fec");
+    if (!dc)
+        return;
+    for(dev = qemu_first_device; dev != NULL; dev = dev->dev_next) {
+        if (dev->dev_class == dc) {
+            if (qemu_device_get_int(dev, "membase") == -1) {
+                qemu_device_set_int(dev, "membase", membase);
+            }
+            if (qemu_device_get_str(dev, "irq")[0] == '\0') {
+                qemu_device_set_str(dev, "irq", 
+                                    qemu_irq_name(buf, sizeof(buf), pic, irq_num));
+            }
+            break;
+        }
+    }
+}
+
+void mcf_fec_class_init(void)
+{
+    QEMUDeviceClass *dc;
+
+    dc = qemu_class_new("mcf_fec", 0, "mcf_fec");
+    qemu_class_add_parent(dc, qemu_eth_class);
+    qemu_class_field_new(dc, "membase", QEMU_CTYPE_INT);
+    qemu_class_set_int(dc, "membase", -1);
+    qemu_class_field_new(dc, "irq", QEMU_CTYPE_STR);
+    dc->dev_init = mcf_fec_dev_init;
+}
+#endif
+
+#ifdef TARGET_CRIS
+void etraxfs_eth_class_init(void)
+{
+    QEMUDeviceClass *dc;
+
+    dc = qemu_class_new("etraxfs_eth", 0, "etraxfs_eth");
+    qemu_class_add_parent(dc, qemu_eth_class);
+}
+#endif
+
+#ifdef TARGET_SPARC
+void lance_class_init(void)
+{
+    QEMUDeviceClass *dc;
+
+    dc = qemu_class_new("lance", 0, "lance");
+    qemu_class_add_parent(dc, qemu_eth_class);
+}
+#endif
+
+void init_classes(void)
+{
+    QEMUDeviceClass *dc, *dc1, *drive_class;
+    QEMUDeviceClass *usb_class, *pci_class;
+    QEMUMachine *m;
+    int i;
+    char buf[128];
+
+    /* preferences */
+    dc = qemu_class_new("preferences", 0, "User preferences");
+    qemu_class_field_new(dc, "ui", QEMU_CTYPE_STR);
+    qemu_class_field_new(dc, "full_screen", QEMU_CTYPE_BOOL);
+    qemu_class_field_new(dc, "keyboard_layout", QEMU_CTYPE_STR);
+
+    qemu_class_field_new(dc, "sdl_no_frame", QEMU_CTYPE_BOOL);
+    qemu_class_field_new(dc, "sdl_alt_grab", QEMU_CTYPE_BOOL);
+    qemu_class_field_new(dc, "sdl_no_quit", QEMU_CTYPE_BOOL);
+    qemu_class_field_new(dc, "sdl_show_cursor", QEMU_CTYPE_BOOL);
+
+    qemu_class_field_new(dc, "vnc_params", QEMU_CTYPE_STR);
+
+    qemu_class_field_new(dc, "daemonize", QEMU_CTYPE_BOOL);
+    qemu_class_field_new(dc, "pidfile", QEMU_CTYPE_STR);
+    qemu_class_field_new(dc, "clock", QEMU_CTYPE_STR);
+    qemu_class_field_new(dc, "tb_size", QEMU_CTYPE_INT);
+
+    /* XXX: add all sound config options and suppress corresponding
+       environment variables */
+
+    /* machines */
+    dc1 = qemu_class_new("generic-machine", QEMU_CLASS_ABSTRACT, NULL);
+    qemu_class_field_new(dc1, "name", QEMU_CTYPE_STR);
+    qemu_class_field_new(dc1, "ramsize", QEMU_CTYPE_INT);
+    qemu_class_field_new(dc1, "cpu", QEMU_CTYPE_STR);
+    qemu_class_field_new(dc1, "kernel", QEMU_CTYPE_STR);
+    qemu_class_field_new(dc1, "append", QEMU_CTYPE_STR);
+    qemu_class_field_new(dc1, "initrd", QEMU_CTYPE_STR);
+    qemu_class_field_new(dc1, "snapshot", QEMU_CTYPE_BOOL);
+    qemu_class_field_new(dc1, "portrait", QEMU_CTYPE_BOOL);
+    qemu_class_field_new(dc1, "boot", QEMU_CTYPE_STR);
+    qemu_class_field_new(dc1, "localtime", QEMU_CTYPE_BOOL);
+    qemu_class_field_new(dc1, "reboot", QEMU_CTYPE_BOOL);
+    qemu_class_set_bool(dc1, "reboot", 1);
+    qemu_class_field_new(dc1, "shutdown", QEMU_CTYPE_BOOL);
+    qemu_class_set_bool(dc1, "shutdown", 1);
+    qemu_class_field_new(dc1, "startdate", QEMU_CTYPE_STR);
+    qemu_class_field_new(dc1, "autostart", QEMU_CTYPE_BOOL);
+    qemu_class_set_bool(dc1, "autostart", 1);
+    qemu_class_field_new(dc1, "smp", QEMU_CTYPE_INT);
+    qemu_class_set_int(dc1, "smp", 1);
+    qemu_class_field_new(dc1, "debug", QEMU_CTYPE_STR);
+    qemu_class_field_new(dc1, "bios_dir", QEMU_CTYPE_STR);
+    qemu_class_field_new(dc1, "bios", QEMU_CTYPE_STR);
+    qemu_class_field_new(dc1, "term_escape_char", QEMU_CTYPE_INT);
+    qemu_class_set_int(dc1, "term_escape_char", 1);
+
+    qemu_class_field_new(dc1, "monitor", QEMU_CTYPE_STR);
+    for(i = 0; i < MAX_SERIAL_PORTS; i++) {
+        snprintf(buf, sizeof(buf), "serial%d", i);
+        qemu_class_field_new(dc1, buf, QEMU_CTYPE_STR);
+    }
+    for(i = 0; i < MAX_PARALLEL_PORTS; i++) {
+        snprintf(buf, sizeof(buf), "parallel%d", i);
+        qemu_class_field_new(dc1, buf, QEMU_CTYPE_STR);
+    }
+    qemu_class_field_new(dc1, "gdb_server", QEMU_CTYPE_STR);
+    qemu_class_field_new(dc1, "usb", QEMU_CTYPE_BOOL);
+    qemu_class_field_new(dc1, "loadvm", QEMU_CTYPE_STR);
+
+    /* register machine classes */
+    for(m = first_machine; m != NULL; m = m->next) {
+        dc = qemu_class_new(m->name, 0, m->desc);
+        qemu_class_add_parent(dc, dc1);
+        /* XXX: move it to machine defs */
+#if defined(TARGET_ARM)
+        qemu_class_field_new(dc, "old_param", QEMU_CTYPE_BOOL);
+#endif
+#if defined(TARGET_ARM) || defined(TARGET_M68K)
+        qemu_class_field_new(dc, "semihosting", QEMU_CTYPE_BOOL);
+#endif
+#ifdef TARGET_I386
+        qemu_class_field_new(dc, "fd_bootchk", QEMU_CTYPE_BOOL);
+        qemu_class_set_bool(dc, "fd_bootchk", 1);
+        qemu_class_field_new(dc, "acpi", QEMU_CTYPE_BOOL);
+        qemu_class_set_bool(dc, "acpi", 1);
+        qemu_class_field_new(dc, "win2k_hack", QEMU_CTYPE_BOOL);
+        /* XXX: add an array type ? */
+        for(i=0;i<MAX_OPTION_ROMS;i++) {
+            snprintf(buf, sizeof(buf), "option_rom%d", i);
+            qemu_class_field_new(dc, buf, QEMU_CTYPE_STR);
+        }
+        qemu_class_field_new(dc, "display", QEMU_CTYPE_STR);
+#ifdef USE_KQEMU
+        qemu_class_field_new(dc, "kqemu", QEMU_CTYPE_STR);
+#endif
+#endif
+#if defined(TARGET_SPARC) || defined(TARGET_PPC)
+        qemu_class_field_new(dc, "display_params", QEMU_CTYPE_STR);
+#ifdef TARGET_SPARC
+        qemu_class_set_str(dc, "display_params", "1024x768x8");
+#else
+        qemu_class_set_str(dc, "display_params", "800x600x15");
+#endif
+#endif
+    }
+
+    /* register drive classes */
+    drive_class = qemu_class_new("generic-drive", QEMU_CLASS_ABSTRACT, NULL);
+    qemu_class_field_new(drive_class, "file", QEMU_CTYPE_STR);
+    qemu_class_field_new(drive_class, "format", QEMU_CTYPE_STR);
+    qemu_class_field_new(drive_class, "media", QEMU_CTYPE_STR);
+    qemu_class_field_new(drive_class, "snapshot", QEMU_CTYPE_BOOL);
+    qemu_class_field_new(drive_class, "cache", QEMU_CTYPE_BOOL);
+    qemu_class_set_bool(drive_class, "cache", 1);
+    qemu_class_field_new(drive_class, "bus", QEMU_CTYPE_INT);
+    qemu_class_field_new(drive_class, "unit", QEMU_CTYPE_INT);
+    qemu_class_set_int(drive_class, "unit", -1);
+    qemu_class_field_new(drive_class, "index", QEMU_CTYPE_INT);
+    qemu_class_set_int(drive_class, "index", -1);
+    qemu_class_field_new(drive_class, "cyls", QEMU_CTYPE_INT);
+    qemu_class_field_new(drive_class, "heads", QEMU_CTYPE_INT);
+    qemu_class_field_new(drive_class, "secs", QEMU_CTYPE_INT);
+    qemu_class_field_new(drive_class, "trans", QEMU_CTYPE_STR);
+    
+    dc = qemu_class_new("ide", 0, "IDE drive");
+    qemu_class_add_parent(dc, drive_class);
+    dc->dev_init = drive_init;
+    
+    dc = qemu_class_new("scsi", 0, "SCSI drive");
+    qemu_class_add_parent(dc, drive_class);
+    dc->dev_init = drive_init;
+
+    dc = qemu_class_new("floppy", 0, "Floppy drive");
+    qemu_class_add_parent(dc, drive_class);
+    dc->dev_init = drive_init;
+
+    dc = qemu_class_new("pflash", 0, "Flash memory");
+    qemu_class_add_parent(dc, drive_class);
+    dc->dev_init = drive_init;
+
+    dc = qemu_class_new("mtd", 0, "MTD drive");
+    qemu_class_add_parent(dc, drive_class);
+    dc->dev_init = drive_init;
+
+    dc = qemu_class_new("sd", 0, "SD drive");
+    qemu_class_add_parent(dc, drive_class);
+    dc->dev_init = drive_init;
+
+    pci_class = qemu_class_new("pci-device", QEMU_CLASS_ABSTRACT, NULL);
+    qemu_class_field_new(pci_class, "pci_bus", QEMU_CTYPE_STR);
+    qemu_class_field_new(pci_class, "devfn", QEMU_CTYPE_INT);
+    qemu_class_set_int(pci_class, "devfn", -1);
+    
+    qemu_isa_class = qemu_class_new("isa-device", QEMU_CLASS_ABSTRACT, NULL);
+
+#ifdef HAS_AUDIO
+    {
+        QEMUDeviceClass *qemu_audio_class;
+        struct soundhw *c;
+        
+        /* register audio devices */
+        qemu_audio_class = qemu_class_new("audio-device", 
+                                          QEMU_CLASS_ABSTRACT, NULL);
+    
+        for (c = soundhw; c->name; ++c) {
+            dc = qemu_class_new(c->name, 0, c->descr);
+            qemu_class_add_parent(dc, qemu_audio_class);
+            if (c->isa) {
+                qemu_class_add_parent(dc, qemu_isa_class);
+                dc->dev_init = isa_audio_init;
+                dc->opaque = c->init.init_isa;
+            } else {
+                qemu_class_add_parent(dc, pci_class);
+                dc->dev_init = pci_audio_init;
+                dc->opaque = c->init.init_pci;
+            }
+        }
+    }
+#endif
+
+    /* network clients except nics */
+    dc = qemu_class_new("net-user", 0, "User mode network router");
+    qemu_class_field_new(dc, "vlan", QEMU_CTYPE_INT);
+    qemu_class_field_new(dc, "hostname", QEMU_CTYPE_STR);
+    qemu_class_field_new(dc, "tftp", QEMU_CTYPE_STR);
+    qemu_class_field_new(dc, "bootp", QEMU_CTYPE_STR);
+#if !defined(_WIN32)
+    qemu_class_field_new(dc, "smb", QEMU_CTYPE_STR);
+#endif
+    for(i = 0; i < SLIRP_MAX_REDIRS; i++) {
+        snprintf(buf, sizeof(buf), "redir%d", i);
+        qemu_class_field_new(dc, buf, QEMU_CTYPE_STR);
+    }
+    dc->dev_init = net_slirp_init;
+
+    dc = qemu_class_new("net-tap", 0, "TAP network interface");
+    qemu_class_field_new(dc, "vlan", QEMU_CTYPE_INT);
+    qemu_class_field_new(dc, "ifname", QEMU_CTYPE_STR);
+#ifndef _WIN32
+    qemu_class_field_new(dc, "fd", QEMU_CTYPE_INT);
+    qemu_class_set_int(dc, "fd", -1);
+    qemu_class_field_new(dc, "script", QEMU_CTYPE_STR);
+    qemu_class_field_new(dc, "downscript", QEMU_CTYPE_STR);
+#endif
+    dc->dev_init = net_tap_init2;
+
+    dc = qemu_class_new("net-socket", 0, "Socket network interface");
+    qemu_class_field_new(dc, "vlan", QEMU_CTYPE_INT);
+    qemu_class_field_new(dc, "fd", QEMU_CTYPE_INT);
+    qemu_class_set_int(dc, "fd", -1);
+    qemu_class_field_new(dc, "listen", QEMU_CTYPE_STR);
+    qemu_class_field_new(dc, "connect", QEMU_CTYPE_STR);
+    qemu_class_field_new(dc, "mcast", QEMU_CTYPE_STR);
+    dc->dev_init = net_socket_init;
+
+    /* network devices */
+    qemu_eth_class = qemu_class_new("ethernet-device", QEMU_CLASS_ABSTRACT, NULL);
+    qemu_class_field_new(qemu_eth_class, "macaddr", QEMU_CTYPE_STR);
+    qemu_class_field_new(qemu_eth_class, "vlan", QEMU_CTYPE_INT);
+    
+    dc = qemu_class_new("ne2k_pci", 0, "NE2000 PCI");
+    qemu_class_add_parent(dc, qemu_eth_class);
+    qemu_class_add_parent(dc, pci_class);
+    dc->dev_init = pci_eth_init;
+    dc->opaque = pci_ne2000_init;
+
+    dc = qemu_class_new("i82551", 0, "i82551");
+    qemu_class_add_parent(dc, qemu_eth_class);
+    qemu_class_add_parent(dc, pci_class);
+    dc->dev_init = pci_eth_init;
+    dc->opaque = pci_i82551_init;
+
+    dc = qemu_class_new("i82557b", 0, "i82557b");
+    qemu_class_add_parent(dc, qemu_eth_class);
+    qemu_class_add_parent(dc, pci_class);
+    dc->dev_init = pci_eth_init;
+    dc->opaque = pci_i82557b_init;
+
+    dc = qemu_class_new("i82559er", 0, "i82559er");
+    qemu_class_add_parent(dc, qemu_eth_class);
+    qemu_class_add_parent(dc, pci_class);
+    dc->dev_init = pci_eth_init;
+    dc->opaque = pci_i82559er_init;
+
+    dc = qemu_class_new("e1000", 0, "e1000");
+    qemu_class_add_parent(dc, qemu_eth_class);
+    qemu_class_add_parent(dc, pci_class);
+    dc->dev_init = pci_eth_init;
+    dc->opaque = pci_e1000_init;
+
+    dc = qemu_class_new("pcnet", 0, "pcnet");
+    qemu_class_add_parent(dc, qemu_eth_class);
+    qemu_class_add_parent(dc, pci_class);
+    dc->dev_init = pci_eth_init;
+    dc->opaque = pci_pcnet_init;
+
+    isa_ne2000_class_init();
+
+#ifdef TARGET_ARM
+    smc91c111_class_init();
+    mv88w8618_eth_class_init();
+    stellaris_enet_class_init();
+#endif
+
+#ifdef TARGET_MIPS
+    mipsnet_class_init();
+#endif
+
+#ifdef TARGET_M68K
+    mcf_fec_class_init();
+#endif
+
+#ifdef TARGET_SPARC
+    lance_class_init();
+#endif
+
+    /* usb devices */
+    usb_class = qemu_class_new("usb-device", QEMU_CLASS_ABSTRACT, NULL);
+
+    dc = qemu_class_new("usb-host", 0, "USB Host Device Redirector");
+    qemu_class_add_parent(dc, usb_class);
+    dc->dev_init = usb_device_init; 
+    qemu_class_field_new(dc, "host_device", QEMU_CTYPE_STR);
+    
+    dc = qemu_class_new("usb-mouse", 0, "USB Mouse");
+    qemu_class_add_parent(dc, usb_class);
+    dc->dev_init = usb_device_init; 
+    dc->opaque = usb_mouse_init;
+
+    dc = qemu_class_new("usb-tablet", 0, "USB Tablet");
+    qemu_class_add_parent(dc, usb_class);
+    dc->dev_init = usb_device_init; 
+    dc->opaque = usb_tablet_init;
+    
+    dc = qemu_class_new("usb-keyboard", 0, "USB Keyboard");
+    qemu_class_add_parent(dc, usb_class);
+    dc->dev_init = usb_device_init; 
+    dc->opaque = usb_keyboard_init;
+
+    dc = qemu_class_new("usb-msd", 0, "USB Mass Storage Device");
+    qemu_class_add_parent(dc, usb_class);
+    dc->dev_init = usb_device_init; 
+    qemu_class_field_new(dc, "file", QEMU_CTYPE_STR);
+
+    dc = qemu_class_new("usb-wacom-tablet", 0, "USB Wacom Tablet");
+    qemu_class_add_parent(dc, usb_class);
+    dc->dev_init = usb_device_init; 
+    dc->opaque = usb_wacom_init;
+    
+    dc = qemu_class_new("usb-serial", 0, "USB Serial Port");
+    qemu_class_add_parent(dc, usb_class);
+    dc->dev_init = usb_device_init; 
+    qemu_class_field_new(dc, "device", QEMU_CTYPE_STR);
+
+#ifdef CONFIG_BRLAPI
+    dc = qemu_class_new("usb-braille", 0, "USB Braille");
+    qemu_class_add_parent(dc, usb_class);
+    dc->dev_init = usb_device_init; 
+    dc->opaque = usb_baum_init;
+#endif
+
+    /* generic PIC */
+    qemu_default_pic_class = qemu_class_new("default-pic", 0,
+                                            "Default Interrupt Controller");
+}
+
+void dev_init(QEMUDevice *dev)
+{
+    int ret;
+    QEMUDeviceClass *dev_class;
+
+    if (dev->instantiated)
+        return;
+    dev->instantiated = 1;
+    dev_class = dev->dev_class;
+    if (!dev_class->dev_init) {
+        ret = -ENOENT;
+    } else {
+        ret = dev_class->dev_init(dev);
+    }
+    if (ret < 0) {
+        fprintf(stderr, "Could not initialize device '%s' (type='%s')\n", 
+                dev->name, dev_class->name);
+    }
+}
+
+void drives_init(void)
+{
+    QEMUDeviceClass *drive_class;
+    QEMUDevice *dev;
+
+    drive_class = qemu_class_find("generic-drive");
+    if (!drive_class)
+        return;
+    for(dev = qemu_first_device; dev != NULL; dev = dev->dev_next) {
+        if (!dev->instantiated) {
+            if (qemu_class_instanceof(dev->dev_class, drive_class)) {
+                dev_init(dev);
+            }
+        }
+    }
+}
+
+/* initialize additional devices */
+void generic_device_init(void)
+{
+    QEMUDevice *dev;
+
+    for(dev = qemu_first_device; dev != NULL; dev = dev->dev_next) {
+        if (!dev->instantiated) {
+            dev_init(dev);
+        }
+    }
+}
+
+/****************************************************/
+
+static const char *str_zton(const char *str)
+{
+    if (str[0] == '\0')
+        return NULL;
+    else
+        return str;
+}
+
 int main(int argc, char **argv)
 {
 #ifdef CONFIG_GDBSTUB
@@ -7681,7 +8739,6 @@
     const char *boot_devices = "";
     DisplayState *ds = &display_state;
     int cyls, heads, secs, translation;
-    const char *net_clients[MAX_NET_CLIENTS];
     int nb_net_clients;
     int hda_index;
     int optind;
@@ -7695,13 +8752,21 @@
     const char *loadvm = NULL;
     QEMUMachine *machine;
     const char *cpu_model;
-    const char *usb_devices[MAX_USB_CMDLINE];
-    int usb_devices_index;
     int fds[2];
     int tb_size;
-    const char *pid_file = NULL;
+    const char *pid_file;
     VLANState *vlan;
-
+    int has_config;
+    const char *slirp_tftp_prefix = NULL;
+    const char *slirp_bootp_filename = NULL;
+    const char *slirp_smb_path = NULL;
+    const char *slirp_redirs[SLIRP_MAX_REDIRS];
+    int nb_slirp_redirs = 0;
+    const char *ui_str;
+    const char *str;
+    const char *prefs_filename;
+    int do_dump_devices;
+    
     LIST_INIT (&vm_change_state_head);
 #ifndef _WIN32
     {
